function bmscex14
clear all;
% EX 1-4
% Illustration of Donsker's Theorem.

% number of increments
n=10^6;

% simulate n bernoulli variables
p=1/2;
ber= binornd(1,p,n,1);

% linear transformation which makes [1,0]--> [1,-1]
y= 2*ber-1;

% sum S with S_0=0
sumprocess= [0;cumsum(y)];

%timestep for the plot
dt=10^(-4);
%time grid
timegrid = 0:dt:1;
t=timegrid(1:(end-1));

% use the linear interpolation formula given in the exercise
% indices are shifted by 1, since we start with at time 0
x=1/sqrt(n)*sumprocess(fix(n*t)+1)+1/sqrt(n)*y(fix(n*t)+1).*(n*t-fix(n*t))'; 

%add terminal value x_1=1/sqrt(n)*S_n
x= [x;1/sqrt(n)*sumprocess(fix(n)+1)];

%plot options
plot(timegrid,x,'r-')
title('Ex 1-4: Donskers Theorem')
xlabel('time');
ylabel('rescaled random walk');
legend(strcat('number of increments=', num2str(n)));
end
